package net.minecraft.src;

import java.io.FileInputStream;
import java.util.Map;
import java.util.Properties;

import net.minecraft.client.Minecraft;

import org.lwjgl.input.Keyboard;

// SDK
@SuppressWarnings({ "rawtypes", "unchecked" })
public class mod_SdkUtility extends SdkBaseModMp
{
	// Blocks
    public static Block blockGrinder;
    
    // Items
    public static final Item itemGoldCoin = (new Item(2509)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGoldCoin.png")).setItemName("itemGoldCoin");
    public static final Item itemLightometer = (new Item(2510)).setIconIndex(ModLoader.getUniqueSpriteIndex("/gui/items.png")).setItemName("itemLightometer");
    public static final Item itemNightvisionGoggles = (new ItemArmor(2513, -1, ModLoader.AddArmor("nightvision"), 0)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemNightvisionGoggles.png")).setItemName("itemNightvision");
    public static final Item itemScubaTank = (new ItemArmor(2521, -1, ModLoader.AddArmor("scubaTank"), 1)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemScubaTank.png")).setItemName("itemScubaTank");
    public static final Item itemParachute = (new SdkItemParachute(2523, ModLoader.AddArmor("parachute"))).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemParachute.png")).setItemName("itemParachute");
    public static final Item itemTelescope = (new SdkItemTelescope(2534)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemTelescope.png")).setItemName("itemTelescope");
    
    // Zoom
    private static final float DEFAULT_ZOOM = 1.0F;
    private static final float[] MAX_ZOOMS = { DEFAULT_ZOOM, 0.5F, 0.25F, 0.125F, 0.0625F };
    private static final float ZOOM_INCREMENT = 0.0625F;
    private static float currentZoom = DEFAULT_ZOOM;
    private static int currentZoomIndex = 0;
    private static int lastZoomSlot = 0;
    private static float lastZoom = currentZoom;
    
    // Properties
	private static int parachuteKey = Keyboard.KEY_P;
	private static int nightvisionKey = Keyboard.KEY_N;
	private static int blockIdGrinder = 120;
	
	// Key bindings
	private static boolean parachuteKeyDown = false;
	private static boolean nightvisionKeyDown = false;
	
	// Nightvision
	public static boolean nightvisionEnabled = false;
	
	static
    {
    	loadProperties();
    }
    
    private static void loadProperties()
    {
    	Properties properties = new Properties();
    	try
    	{
    		String propertiesPath = mod_SdkUtility.class.getProtectionDomain().getCodeSource().getLocation().toURI().getPath();
    		propertiesPath = propertiesPath.substring(0, propertiesPath.lastIndexOf('/') + 1);
    		propertiesPath += "mod_SdkUtility.properties";
    		
    		properties.load(new FileInputStream(propertiesPath));
    		String property;
    		
    		property = properties.getProperty("parachuteKey");
    		int tempParachuteKey = Keyboard.getKeyIndex(property.trim().toUpperCase());
    		if(tempParachuteKey == Keyboard.CHAR_NONE)
    		{
    			System.out.println("Error binding parachute key. Bad key name: " + property.trim());
    		}
    		else
    		{
    			parachuteKey = tempParachuteKey;
    		}
    		
    		property = properties.getProperty("nightvisionKey");
    		int tempNightvisionKey = Keyboard.getKeyIndex(property.trim().toUpperCase());
    		if(tempNightvisionKey == Keyboard.CHAR_NONE)
    		{
    			System.out.println("Error binding nightvision key. Bad key name: " + property.trim());
    		}
    		else
    		{
    			nightvisionKey = tempNightvisionKey;
    		}
    		
    		property = properties.getProperty("blockIdGrinder");
    		blockIdGrinder = Integer.parseInt(property.trim());
        }
        catch(Exception e)
        {
        	System.out.println("Error loading properties.");
			e.printStackTrace();
        }
    }
    
    @Override
    public void InitBlocks()
    {
    	blockGrinder = (new SdkBlockGrinder(blockIdGrinder, ModLoader.addOverride("/terrain.png", "/sdk/blockGrinder.png"))).setHardness(3.5F).setStepSound(Block.soundStoneFootstep).setBlockName("blockGrinder");
    }
	
	public mod_SdkUtility()
    {
		super();
		
		ModLoader.RegisterBlock(blockGrinder);
		
		ModLoader.AddName(blockGrinder, "Grinder");
		
		ModLoader.AddName(itemGoldCoin, "Gold Coin");
		ModLoader.AddName(itemLightometer, "Lightometer");
		ModLoader.AddName(itemNightvisionGoggles, "Nightvision Goggles");
		ModLoader.AddName(itemScubaTank, "Scuba Tank");
		ModLoader.AddName(itemParachute, "Parachute");
		ModLoader.AddName(itemTelescope, "Telescope");
		
		ModLoader.RegisterEntityID(SdkEntityParachute.class, "Parachute", ModLoader.getUniqueEntityId());
		
		ModLoader.RegisterTileEntity(SdkTileEntityGrinder.class, "Grinder");
		
		ModLoader.RegisterGUI(instance, SdkGuiGrinder.class);
    }
	
	@Override
	public String Version()
	{
		return "1.3_01v4";
	}
    
	@Override
    public void RegisterAnimation(Minecraft minecraft)
    {
		ModLoader.addAnimation(new SdkTextureLightometerFX(minecraft));
    }
	
	@Override
	public void OnTickInGameTick(Minecraft minecraft)
	{
		// Scuba tank
		ItemStack scubaTank = minecraft.thePlayer.inventory.armorItemInSlot(2);
        if(scubaTank != null && scubaTank.itemID == itemScubaTank.shiftedIndex)
        	minecraft.thePlayer.air = minecraft.thePlayer.maxAir;
        
        // Nightvision
        ItemStack nightvisionGoggles = minecraft.thePlayer.inventory.armorItemInSlot(3);
        if(nightvisionGoggles == null || nightvisionGoggles.itemID != itemNightvisionGoggles.shiftedIndex)
        	nightvisionEnabled = false;
        
        // Zoom
    	handleZoom(minecraft);
        
    	// Parachute hotkey
        if(minecraft.currentScreen == null && !Keyboard.isKeyDown(parachuteKey))
        	if(parachuteKeyDown)
        		handleParachuteKey(minecraft);
        parachuteKeyDown = Keyboard.isKeyDown(parachuteKey);
        
        // Nightvision hotkey
        if(minecraft.currentScreen == null && !Keyboard.isKeyDown(nightvisionKey))
        	if(nightvisionKeyDown)
        		handleNightvisionKey();
        nightvisionKeyDown = Keyboard.isKeyDown(nightvisionKey);
	}

	@Override
	public void OnTickInGame(Minecraft minecraft)
	{
		super.OnTickInGame(minecraft);
		
		// Drawing
		renderNightvisionOverlay(minecraft);
		renderScopeOverlay(minecraft);
	}

	private void handleZoom(Minecraft minecraft)
	{
		ItemStack itemStack = minecraft.thePlayer.inventory.getCurrentItem();
		if(itemStack == null
				|| itemStack.getItem() != itemTelescope
				|| minecraft.thePlayer.inventory.currentItem != lastZoomSlot
				|| minecraft.gameSettings.thirdPersonView
				|| minecraft.currentScreen != null)
		{
			currentZoomIndex = 0;
		}
		lastZoomSlot = minecraft.thePlayer.inventory.currentItem;
		
		float targetZoom = MAX_ZOOMS[currentZoomIndex];
		if(currentZoom > targetZoom)
			currentZoom = Math.max(targetZoom, currentZoom - ZOOM_INCREMENT);
		else if(currentZoom < targetZoom)
			currentZoom = Math.min(targetZoom, currentZoom + ZOOM_INCREMENT);
		
		if(currentZoom != lastZoom)
			minecraft.entityRenderer.func_21152_a(1 / currentZoom, 0, 0);
		
		lastZoom = currentZoom;
	}

	private void renderNightvisionOverlay(Minecraft minecraft)
	{
		if(nightvisionEnabled())
	        SdkTools.renderTextureOverlay("%blur%/sdk/miscNightvision.png", 1F);
	}
	
	public static boolean nightvisionEnabled()
	{
		ItemStack itemstack = SdkTools.minecraft.thePlayer.inventory.armorItemInSlot(3);
		
		return itemstack != null
		&& itemstack.itemID == itemNightvisionGoggles.shiftedIndex
		&& !SdkTools.minecraft.gameSettings.thirdPersonView
		&& SdkTools.minecraft.currentScreen == null
		&& nightvisionEnabled;
	}
	
	private void renderScopeOverlay(Minecraft minecraft)
	{
		if(!minecraft.gameSettings.thirdPersonView && currentZoom != DEFAULT_ZOOM && minecraft.currentScreen == null)
	        SdkTools.renderTextureOverlay("%blur%/sdk/miscScope.png", 1F);
	}

	public void handleParachuteKey(Minecraft minecraft)
	{
		ItemStack itemstack = minecraft.thePlayer.inventory.armorInventory[2];
		if(itemstack != null && itemstack.itemID == itemParachute.shiftedIndex)
		{
			useParachute(itemstack, minecraft.theWorld, minecraft.thePlayer);
			
			Packet200ModLoader packet = new Packet200ModLoader();
			packet.packetType = 0;
			ModLoaderMp.SendPacket(this, packet);
		}
	}
	
	public static void handleNightvisionKey()
	{
		nightvisionEnabled = !nightvisionEnabled;
	}

	@Override
	public void OnMainMenu() { }

	@Override
	public void SetRecipes(CraftingManager craftingmanager) {
		SdkTools.setShapedRecipe(craftingmanager, true, new ItemStack(itemGoldCoin, 4), new Object[] {
            "#", Character.valueOf('#'), Item.ingotGold
        });
		SdkTools.setShapedRecipe(craftingmanager, true, new ItemStack(itemLightometer, 1), new Object[] {
        	" # ", "#X#", " # ", Character.valueOf('#'), Item.ingotIron, Character.valueOf('X'), Item.lightStoneDust
        });
		SdkTools.setShapedRecipe(craftingmanager, true, new ItemStack(itemNightvisionGoggles, 1), new Object[] {
        	"#X#", Character.valueOf('#'), Item.diamond, Character.valueOf('X'), Item.silk
        });
		SdkTools.setShapedRecipe(craftingmanager, true, new ItemStack(itemScubaTank, 1), new Object[] {
        	"###", "# #", "###", Character.valueOf('#'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(craftingmanager, true, new ItemStack(itemParachute, 1), new Object[] {
        	"###", "XYX", "YYY", Character.valueOf('#'), Block.cloth, Character.valueOf('X'), Item.silk, Character.valueOf('Y'), Item.leather
        });
		SdkTools.setShapedRecipe(craftingmanager, true, new ItemStack(blockGrinder, 1), new Object[] {
        	"###", "#X#", "###", Character.valueOf('#'), Block.cobblestone, Character.valueOf('X'), Item.diamond
        });
		SdkTools.setShapedRecipe(craftingmanager, true, new ItemStack(itemTelescope), new Object[] {
        	"#", "X", "X", Character.valueOf('#'), Item.diamond, Character.valueOf('X'), Item.ingotGold
        });
	}
	
	@Override
	public void AddRenderer(Map map)
	{
		map.put(SdkEntityParachute.class, new SdkRenderParachute());
	}
	
	@Override
	public GuiScreen OpenModGUI(EntityPlayer entityplayer, Class class1, Object obj)
    {
        if(obj instanceof SdkGuiGrinder)
        	return (SdkGuiGrinder)obj;
        else
        	return null;
    }
	
	@Override
	public void AddNetClientHandlerEntities(Map<Integer, Class> map)
	{
		map.put(120, SdkEntityParachute.class);
	}
	
	private void useParachute(ItemStack itemstack, World world, EntityPlayer entityplayer)
	{
		if(!SdkEntityParachute.onGroundOrInWater(world, entityplayer))
    	{
	        itemstack.damageItem(1);
            if(itemstack.stackSize == 0)
            {
            	boolean removed = false;
            	for(int i = 0; i < entityplayer.inventory.armorInventory.length; i++)
            	{
            		if(entityplayer.inventory.armorInventory[i] == itemstack)
            		{
            			entityplayer.inventory.armorInventory[i] = null;
            			removed = true;
            			break;
            		}
            	}
            	
            	if(!removed)
            	{
	            	for(int i = 0; i < entityplayer.inventory.mainInventory.length; i++)
	            	{
	            		if(entityplayer.inventory.mainInventory[i] == itemstack)
	            		{
	            			entityplayer.inventory.mainInventory[i] = null;
	            			removed = true;
	            			break;
	            		}
	            	}
            	}
            }
	        
	        world.playSoundAtEntity(entityplayer, "sdk.parachute", 0.5F, 1.0F / (SdkTools.random.nextFloat() * 0.1F + 0.95F));
	        
	        if(!world.multiplayerWorld)
	        {
	        	world.entityJoinedWorld(new SdkEntityParachute(world, entityplayer));
	        }
    	}
	}
    
    public static void useZoom()
    {
    	currentZoomIndex = (currentZoomIndex + 1) % MAX_ZOOMS.length;
    }
}
